// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2007
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.0.0 (2006/06/28)

#include "WMaterialTree.h"
using namespace Wm4;

//----------------------------------------------------------------------------
WMaterialTree::WMaterialTree (MaterialState* pkMState)
{
    m_spkMState = pkMState;
}
//----------------------------------------------------------------------------
void WMaterialTree::SetMChildQuantity (int iQuantity)
{
    m_kMChild.resize(iQuantity);
}
//----------------------------------------------------------------------------
int WMaterialTree::GetMChildQuantity () const
{
    return (int)m_kMChild.size();
}
//----------------------------------------------------------------------------
void WMaterialTree::SetMaterial (MaterialState* pkMState)
{
    m_spkMState = pkMState;
}
//----------------------------------------------------------------------------
MaterialStatePtr WMaterialTree::GetMaterial () const
{
    return m_spkMState;
}
//----------------------------------------------------------------------------
WMaterialTree& WMaterialTree::GetMChild (int i)
{
    return m_kMChild[i];
}
//----------------------------------------------------------------------------
void WMaterialTree::SetTChildQuantity (int iQuantity)
{
    m_kTChild.resize(iQuantity);
}
//----------------------------------------------------------------------------
int WMaterialTree::GetTChildQuantity () const
{
    return (int)m_kTChild.size();
}
//----------------------------------------------------------------------------
TextureEffectPtr WMaterialTree::GetEffect (int i)
{
    return m_kTChild[i].GetEffect();
}
//----------------------------------------------------------------------------
WTextureTree& WMaterialTree::GetTChild (int i)
{
    return m_kTChild[i];
}
//----------------------------------------------------------------------------
